(function(root,factory){if(typeof define==="function"&&define.amd){define([],factory)}else if(typeof exports==="object"){module.exports=factory()}else{root.buckets=factory()}})(this,function(){"use strict";var buckets={};buckets.defaultCompare=function(a,b){if(a<b){return-1}if(a===b){return 0}return 1};buckets.defaultEquals=function(a,b){return a===b};buckets.defaultToString=function(item){if(item===null){return"BUCKETS_NULL"}if(buckets.isUndefined(item)){return"BUCKETS_UNDEFINED"}if(buckets.isString(item)){return item}return item.toString()};buckets.isFunction=function(func){return typeof func==="function"};buckets.isUndefined=function(obj){return typeof obj==="undefined"};buckets.isString=function(obj){return Object.prototype.toString.call(obj)==="[object String]"};buckets.reverseCompareFunction=function(compareFunction){if(!buckets.isFunction(compareFunction)){return function(a,b){if(a<b){return 1}if(a===b){return 0}return-1}}return function(d,v){return compareFunction(d,v)*-1}};buckets.compareToEquals=function(compareFunction){return function(a,b){return compareFunction(a,b)===0}};buckets.arrays={};buckets.arrays.indexOf=function(array,item,equalsFunction){var equals=equalsFunction||buckets.defaultEquals;var length=array.length;for(var i=0;i<length;i++){if(equals(array[i],item)){return i}}return-1};buckets.arrays.lastIndexOf=function(array,item,equalsFunction){var equals=equalsFunction||buckets.defaultEquals;var length=array.length;for(var i=length-1;i>=0;i--){if(equals(array[i],item)){return i}}return-1};buckets.arrays.contains=function(array,item,equalsFunction){return buckets.arrays.indexOf(array,item,equalsFunction)>=0};buckets.arrays.remove=function(array,item,equalsFunction){var index=buckets.arrays.indexOf(array,item,equalsFunction);if(index<0){return false}array.splice(index,1);return true};buckets.arrays.frequency=function(array,item,equalsFunction){var equals=equalsFunction||buckets.defaultEquals;var length=array.length;var freq=0;for(var i=0;i<length;i++){if(equals(array[i],item)){freq++}}return freq};buckets.arrays.equals=function(array1,array2,equalsFunction){var equals=equalsFunction||buckets.defaultEquals;if(array1.length!==array2.length){return false}var length=array1.length;for(var i=0;i<length;i++){if(!equals(array1[i],array2[i])){return false}}return true};buckets.arrays.copy=function(array){return array.concat()};buckets.arrays.swap=function(array,i,j){if(i<0||i>=array.length||j<0||j>=array.length){return false}var temp=array[i];array[i]=array[j];array[j]=temp;return true};buckets.arrays.forEach=function(array,callback){var lenght=array.length;for(var i=0;i<lenght;i++){if(callback(array[i])===false){return}}};buckets.LinkedList=function(){this.firstNode=null;this.lastNode=null;this.nElements=0};buckets.LinkedList.prototype.add=function(item,index){if(buckets.isUndefined(index)){index=this.nElements}if(index<0||index>this.nElements||buckets.isUndefined(item)){return false}var newNode=this.createNode(item);if(this.nElements===0){this.firstNode=newNode;this.lastNode=newNode}else if(index===this.nElements){this.lastNode.next=newNode;this.lastNode=newNode}else if(index===0){newNode.next=this.firstNode;this.firstNode=newNode}else{var prev=this.nodeAtIndex(index-1);newNode.next=prev.next;prev.next=newNode}this.nElements++;return true};buckets.LinkedList.prototype.first=function(){if(this.firstNode!==null){return this.firstNode.element}return undefined};buckets.LinkedList.prototype.last=function(){if(this.lastNode!==null){return this.lastNode.element}return undefined};buckets.LinkedList.prototype.elementAtIndex=function(index){var node=this.nodeAtIndex(index);if(node===null){return undefined}return node.element};buckets.LinkedList.prototype.indexOf=function(item,equalsFunction){var equalsF=equalsFunction||buckets.defaultEquals;if(buckets.isUndefined(item)){return-1}var currentNode=this.firstNode;var index=0;while(currentNode!==null){if(equalsF(currentNode.element,item)){return index}index++;currentNode=currentNode.next}return-1};buckets.LinkedList.prototype.contains=function(item,equalsFunction){return this.indexOf(item,equalsFunction)>=0};buckets.LinkedList.prototype.remove=function(item,equalsFunction){var equalsF=equalsFunction||buckets.defaultEquals;if(this.nElements<1||buckets.isUndefined(item)){return false}var previous=null;var currentNode=this.firstNode;while(currentNode!==null){if(equalsF(currentNode.element,item)){if(currentNode===this.firstNode){this.firstNode=this.firstNode.next;if(currentNode===this.lastNode){this.lastNode=null}}else if(currentNode===this.lastNode){this.lastNode=previous;previous.next=currentNode.next;currentNode.next=null}else{previous.next=currentNode.next;currentNode.next=null}this.nElements--;return true}previous=currentNode;currentNode=currentNode.next}return false};buckets.LinkedList.prototype.clear=function(){this.firstNode=null;this.lastNode=null;this.nElements=0};buckets.LinkedList.prototype.equals=function(other,equalsFunction){var eqF=equalsFunction||buckets.defaultEquals;if(!(other instanceof buckets.LinkedList)){return false}if(this.size()!==other.size()){return false}return this.equalsAux(this.firstNode,other.firstNode,eqF)};buckets.LinkedList.prototype.equalsAux=function(n1,n2,eqF){while(n1!==null){if(!eqF(n1.element,n2.element)){return false}n1=n1.next;n2=n2.next}return true};buckets.LinkedList.prototype.removeElementAtIndex=function(index){if(index<0||index>=this.nElements){return undefined}var element;if(this.nElements===1){element=this.firstNode.element;this.firstNode=null;this.lastNode=null}else{var previous=this.nodeAtIndex(index-1);if(previous===null){element=this.firstNode.element;this.firstNode=this.firstNode.next}else if(previous.next===this.lastNode){element=this.lastNode.element;this.lastNode=previous}if(previous!==null){element=previous.next.element;previous.next=previous.next.next}}this.nElements--;return element};buckets.LinkedList.prototype.forEach=function(callback){var currentNode=this.firstNode;while(currentNode!==null){if(callback(currentNode.element)===false){break}currentNode=currentNode.next}};buckets.LinkedList.prototype.reverse=function(){var previous=null;var current=this.firstNode;var temp=null;while(current!==null){temp=current.next;current.next=previous;previous=current;current=temp}temp=this.firstNode;this.firstNode=this.lastNode;this.lastNode=temp};buckets.LinkedList.prototype.toArray=function(){var array=[];var currentNode=this.firstNode;while(currentNode!==null){array.push(currentNode.element);currentNode=currentNode.next}return array};buckets.LinkedList.prototype.size=function(){return this.nElements};buckets.LinkedList.prototype.isEmpty=function(){return this.nElements<=0};buckets.LinkedList.prototype.nodeAtIndex=function(index){if(index<0||index>=this.nElements){return null}if(index===this.nElements-1){return this.lastNode}var node=this.firstNode;for(var i=0;i<index;i++){node=node.next}return node};buckets.LinkedList.prototype.createNode=function(item){return{element:item,next:null}};buckets.Dictionary=function(toStrFunction){this.table={};this.nElements=0;this.toStr=toStrFunction||buckets.defaultToString};buckets.Dictionary.prototype.get=function(key){var pair=this.table[this.toStr(key)];if(buckets.isUndefined(pair)){return undefined}return pair.value};buckets.Dictionary.prototype.set=function(key,value){if(buckets.isUndefined(key)||buckets.isUndefined(value)){return undefined}var ret;var k=this.toStr(key);var previousElement=this.table[k];if(buckets.isUndefined(previousElement)){this.nElements++;ret=undefined}else{ret=previousElement.value}this.table[k]={key:key,value:value};return ret};buckets.Dictionary.prototype.remove=function(key){var k=this.toStr(key);var previousElement=this.table[k];if(!buckets.isUndefined(previousElement)){delete this.table[k];this.nElements--;return previousElement.value}return undefined};buckets.Dictionary.prototype.keys=function(){var array=[];for(var name in this.table){if(this.table.hasOwnProperty(name)){array.push(this.table[name].key)}}return array};buckets.Dictionary.prototype.values=function(){var array=[];for(var name in this.table){if(this.table.hasOwnProperty(name)){array.push(this.table[name].value)}}return array};buckets.Dictionary.prototype.forEach=function(callback){for(var name in this.table){if(this.table.hasOwnProperty(name)){var pair=this.table[name];var ret=callback(pair.key,pair.value);if(ret===false){return}}}};buckets.Dictionary.prototype.containsKey=function(key){return!buckets.isUndefined(this.get(key))};buckets.Dictionary.prototype.clear=function(){this.table={};this.nElements=0};buckets.Dictionary.prototype.size=function(){return this.nElements};buckets.Dictionary.prototype.isEmpty=function(){return this.nElements<=0};buckets.MultiDictionary=function(toStrFunction,valuesEqualsFunction){this.parent=new buckets.Dictionary(toStrFunction);this.equalsF=valuesEqualsFunction||buckets.defaultEquals};buckets.MultiDictionary.prototype.get=function(key){var values=this.parent.get(key);if(buckets.isUndefined(values)){return[]}return buckets.arrays.copy(values)};buckets.MultiDictionary.prototype.set=function(key,value){if(buckets.isUndefined(key)||buckets.isUndefined(value)){return false}if(!this.containsKey(key)){this.parent.set(key,[value]);return true}var array=this.parent.get(key);if(buckets.arrays.contains(array,value,this.equalsF)){return false}array.push(value);return true};buckets.MultiDictionary.prototype.remove=function(key,value){if(buckets.isUndefined(value)){var v=this.parent.remove(key);if(buckets.isUndefined(v)){return false}return true}var array=this.parent.get(key);if(buckets.arrays.remove(array,value,this.equalsF)){if(array.length===0){this.parent.remove(key)}return true}return false};buckets.MultiDictionary.prototype.keys=function(){return this.parent.keys()};buckets.MultiDictionary.prototype.values=function(){var values=this.parent.values();var array=[];for(var i=0;i<values.length;i++){var v=values[i];for(var j=0;j<v.length;j++){array.push(v[j])}}return array};buckets.MultiDictionary.prototype.containsKey=function(key){return this.parent.containsKey(key)};buckets.MultiDictionary.prototype.clear=function(){return this.parent.clear()};buckets.MultiDictionary.prototype.size=function(){return this.parent.size()};buckets.MultiDictionary.prototype.isEmpty=function(){return this.parent.isEmpty()};buckets.Heap=function(compareFunction){this.data=[];this.compare=compareFunction||buckets.defaultCompare};buckets.Heap.prototype.leftChildIndex=function(nodeIndex){return 2*nodeIndex+1};buckets.Heap.prototype.rightChildIndex=function(nodeIndex){return 2*nodeIndex+2};buckets.Heap.prototype.parentIndex=function(nodeIndex){return Math.floor((nodeIndex-1)/2)};buckets.Heap.prototype.minIndex=function(leftChild,rightChild){if(rightChild>=this.data.length){if(leftChild>=this.data.length){return-1}else{return leftChild}}else{if(this.compare(this.data[leftChild],this.data[rightChild])<=0){return leftChild}else{return rightChild}}};buckets.Heap.prototype.siftUp=function(index){var parent=this.parentIndex(index);while(index>0&&this.compare(this.data[parent],this.data[index])>0){buckets.arrays.swap(this.data,parent,index);index=parent;parent=this.parentIndex(index)}};buckets.Heap.prototype.siftDown=function(nodeIndex){var min=this.minIndex(this.leftChildIndex(nodeIndex),this.rightChildIndex(nodeIndex));while(min>=0&&this.compare(this.data[nodeIndex],this.data[min])>0){buckets.arrays.swap(this.data,min,nodeIndex);nodeIndex=min;min=this.minIndex(this.leftChildIndex(nodeIndex),this.rightChildIndex(nodeIndex))}};buckets.Heap.prototype.peek=function(){if(this.data.length>0){return this.data[0]}else{return undefined}};buckets.Heap.prototype.add=function(element){if(buckets.isUndefined(element)){return undefined}this.data.push(element);this.siftUp(this.data.length-1);return true};buckets.Heap.prototype.removeRoot=function(){if(this.data.length>0){var obj=this.data[0];this.data[0]=this.data[this.data.length-1];this.data.splice(this.data.length-1,1);if(this.data.length>0){this.siftDown(0)}return obj}return undefined};buckets.Heap.prototype.contains=function(element){var equF=buckets.compareToEquals(this.compare);return buckets.arrays.contains(this.data,element,equF)};buckets.Heap.prototype.size=function(){return this.data.length};buckets.Heap.prototype.isEmpty=function(){return this.data.length<=0};buckets.Heap.prototype.clear=function(){this.data.length=0};buckets.Heap.prototype.forEach=function(callback){buckets.arrays.forEach(this.data,callback)};buckets.Stack=function(){this.list=new buckets.LinkedList};buckets.Stack.prototype.push=function(elem){return this.list.add(elem,0)};buckets.Stack.prototype.add=function(elem){return this.list.add(elem,0)};buckets.Stack.prototype.pop=function(){return this.list.removeElementAtIndex(0)};buckets.Stack.prototype.peek=function(){return this.list.first()};buckets.Stack.prototype.size=function(){return this.list.size()};buckets.Stack.prototype.contains=function(elem,equalsFunction){return this.list.contains(elem,equalsFunction)};buckets.Stack.prototype.isEmpty=function(){return this.list.isEmpty()};buckets.Stack.prototype.clear=function(){this.list.clear()};buckets.Stack.prototype.forEach=function(callback){this.list.forEach(callback)};buckets.Queue=function(){this.list=new buckets.LinkedList};buckets.Queue.prototype.enqueue=function(elem){return this.list.add(elem)};buckets.Queue.prototype.add=function(elem){return this.list.add(elem)};buckets.Queue.prototype.dequeue=function(){if(this.list.size()!==0){var el=this.list.first();this.list.removeElementAtIndex(0);return el}return undefined};buckets.Queue.prototype.peek=function(){if(this.list.size()!==0){return this.list.first()}return undefined};buckets.Queue.prototype.size=function(){return this.list.size()};buckets.Queue.prototype.contains=function(elem,equalsFunction){return this.list.contains(elem,equalsFunction)};buckets.Queue.prototype.isEmpty=function(){return this.list.size()<=0};buckets.Queue.prototype.clear=function(){this.list.clear()};buckets.Queue.prototype.forEach=function(callback){this.list.forEach(callback)};buckets.PriorityQueue=function(compareFunction){this.heap=new buckets.Heap(buckets.reverseCompareFunction(compareFunction))};buckets.PriorityQueue.prototype.enqueue=function(element){return this.heap.add(element)};buckets.PriorityQueue.prototype.add=function(element){return this.heap.add(element)};buckets.PriorityQueue.prototype.dequeue=function(){if(this.heap.size()!==0){var el=this.heap.peek();this.heap.removeRoot();return el}return undefined};buckets.PriorityQueue.prototype.peek=function(){return this.heap.peek()};buckets.PriorityQueue.prototype.contains=function(element){return this.heap.contains(element)};buckets.PriorityQueue.prototype.isEmpty=function(){return this.heap.isEmpty()};buckets.PriorityQueue.prototype.size=function(){return this.heap.size()};buckets.PriorityQueue.prototype.clear=function(){this.heap.clear()};buckets.PriorityQueue.prototype.forEach=function(callback){this.heap.forEach(callback)};buckets.Set=function(toStringFunction){this.dictionary=new buckets.Dictionary(toStringFunction)};buckets.Set.prototype.contains=function(element){return this.dictionary.containsKey(element)};buckets.Set.prototype.add=function(element){if(this.contains(element)||buckets.isUndefined(element)){return false}else{this.dictionary.set(element,element);return true}};buckets.Set.prototype.intersection=function(otherSet){var set=this;this.forEach(function(element){if(!otherSet.contains(element)){set.remove(element)}})};buckets.Set.prototype.union=function(otherSet){var set=this;otherSet.forEach(function(element){set.add(element)})};buckets.Set.prototype.difference=function(otherSet){var set=this;otherSet.forEach(function(element){set.remove(element)})};buckets.Set.prototype.isSubsetOf=function(otherSet){if(this.size()>otherSet.size()){return false}var isSub=true;this.forEach(function(element){if(!otherSet.contains(element)){isSub=false;return false}});return isSub};buckets.Set.prototype.remove=function(element){if(!this.contains(element)){return false}else{this.dictionary.remove(element);return true}};buckets.Set.prototype.forEach=function(callback){this.dictionary.forEach(function(k,v){return callback(v)})};buckets.Set.prototype.toArray=function(){return this.dictionary.values()};buckets.Set.prototype.isEmpty=function(){return this.dictionary.isEmpty()};buckets.Set.prototype.size=function(){return this.dictionary.size()};buckets.Set.prototype.clear=function(){this.dictionary.clear()};buckets.Bag=function(toStrFunction){this.toStrF=toStrFunction||buckets.defaultToString;this.dictionary=new buckets.Dictionary(this.toStrF);this.nElements=0};buckets.Bag.prototype.add=function(element,nCopies){if(isNaN(nCopies)||buckets.isUndefined(nCopies)){nCopies=1}if(buckets.isUndefined(element)||nCopies<=0){return false}if(!this.contains(element)){var node={value:element,copies:nCopies};this.dictionary.set(element,node)}else{this.dictionary.get(element).copies+=nCopies}this.nElements+=nCopies;return true};buckets.Bag.prototype.count=function(element){if(!this.contains(element)){return 0}else{return this.dictionary.get(element).copies}};buckets.Bag.prototype.contains=function(element){return this.dictionary.containsKey(element)};buckets.Bag.prototype.remove=function(element,nCopies){if(isNaN(nCopies)||buckets.isUndefined(nCopies)){nCopies=1}if(buckets.isUndefined(element)||nCopies<=0){return false}if(!this.contains(element)){return false}else{var node=this.dictionary.get(element);if(nCopies>node.copies){this.nElements-=node.copies}else{this.nElements-=nCopies}node.copies-=nCopies;if(node.copies<=0){this.dictionary.remove(element)}return true}};buckets.Bag.prototype.toArray=function(){var a=[];var values=this.dictionary.values();var vl=values.length;for(var i=0;i<vl;i++){var node=values[i];var element=node.value;var copies=node.copies;for(var j=0;j<copies;j++){a.push(element)}}return a};buckets.Bag.prototype.toSet=function(){var set=new buckets.Set(this.toStrF);var elements=this.dictionary.values();var l=elements.length;for(var i=0;i<l;i++){var value=elements[i].value;set.add(value)}return set};buckets.Bag.prototype.forEach=function(callback){this.dictionary.forEach(function(k,v){var value=v.value;var copies=v.copies;for(var i=0;i<copies;i++){if(callback(value)===false){return false}}return true})};buckets.Bag.prototype.size=function(){return this.nElements};buckets.Bag.prototype.isEmpty=function(){return this.nElements===0};buckets.Bag.prototype.clear=function(){this.nElements=0;this.dictionary.clear()};buckets.BSTree=function(compareFunction){this.root=null;this.compare=compareFunction||buckets.defaultCompare;this.nElements=0};buckets.BSTree.prototype.add=function(element){if(buckets.isUndefined(element)){return false}if(this.insertNode(this.createNode(element))!==null){this.nElements++;return true}return false};buckets.BSTree.prototype.clear=function(){this.root=null;this.nElements=0};buckets.BSTree.prototype.isEmpty=function(){return this.nElements===0};buckets.BSTree.prototype.size=function(){return this.nElements};buckets.BSTree.prototype.contains=function(element){if(buckets.isUndefined(element)){return false}return this.searchNode(this.root,element)!==null};buckets.BSTree.prototype.remove=function(element){var node=this.searchNode(this.root,element);if(node===null){return false}this.removeNode(node);this.nElements--;return true};buckets.BSTree.prototype.inorderTraversal=function(callback){this.inorderTraversalAux(this.root,callback,{stop:false})};buckets.BSTree.prototype.preorderTraversal=function(callback){this.preorderTraversalAux(this.root,callback,{stop:false})};buckets.BSTree.prototype.postorderTraversal=function(callback){this.postorderTraversalAux(this.root,callback,{stop:false})};buckets.BSTree.prototype.levelTraversal=function(callback){this.levelTraversalAux(this.root,callback)};buckets.BSTree.prototype.minimum=function(){if(this.isEmpty()){return undefined}return this.minimumAux(this.root).element};buckets.BSTree.prototype.maximum=function(){if(this.isEmpty()){return undefined}return this.maximumAux(this.root).element};buckets.BSTree.prototype.forEach=function(callback){this.inorderTraversal(callback)};buckets.BSTree.prototype.toArray=function(){var array=[];this.inorderTraversal(function(element){array.push(element)});return array};buckets.BSTree.prototype.height=function(){return this.heightAux(this.root)};buckets.BSTree.prototype.searchNode=function(node,element){var cmp=null;while(node!==null&&cmp!==0){cmp=this.compare(element,node.element);if(cmp<0){node=node.leftCh}else if(cmp>0){node=node.rightCh}}return node};buckets.BSTree.prototype.transplant=function(n1,n2){if(n1.parent===null){this.root=n2}else if(n1===n1.parent.leftCh){n1.parent.leftCh=n2}else{n1.parent.rightCh=n2}if(n2!==null){n2.parent=n1.parent}};buckets.BSTree.prototype.removeNode=function(node){if(node.leftCh===null){this.transplant(node,node.rightCh)}else if(node.rightCh===null){this.transplant(node,node.leftCh)}else{var y=this.minimumAux(node.rightCh);if(y.parent!==node){this.transplant(y,y.rightCh);y.rightCh=node.rightCh;y.rightCh.parent=y}this.transplant(node,y);y.leftCh=node.leftCh;y.leftCh.parent=y}};buckets.BSTree.prototype.inorderTraversalAux=function(node,callback,signal){if(node===null||signal.stop){return}this.inorderTraversalAux(node.leftCh,callback,signal);if(signal.stop){return}signal.stop=callback(node.element)===false;if(signal.stop){return}this.inorderTraversalAux(node.rightCh,callback,signal)};buckets.BSTree.prototype.levelTraversalAux=function(node,callback){var queue=new buckets.Queue;if(node!==null){queue.enqueue(node)}while(!queue.isEmpty()){node=queue.dequeue();if(callback(node.element)===false){return}if(node.leftCh!==null){queue.enqueue(node.leftCh)}if(node.rightCh!==null){queue.enqueue(node.rightCh)}}};buckets.BSTree.prototype.preorderTraversalAux=function(node,callback,signal){if(node===null||signal.stop){return}signal.stop=callback(node.element)===false;if(signal.stop){return}this.preorderTraversalAux(node.leftCh,callback,signal);if(signal.stop){return}this.preorderTraversalAux(node.rightCh,callback,signal)};buckets.BSTree.prototype.postorderTraversalAux=function(node,callback,signal){if(node===null||signal.stop){return}this.postorderTraversalAux(node.leftCh,callback,signal);if(signal.stop){return}this.postorderTraversalAux(node.rightCh,callback,signal);if(signal.stop){return}signal.stop=callback(node.element)===false};buckets.BSTree.prototype.minimumAux=function(node){while(node.leftCh!==null){node=node.leftCh}return node};buckets.BSTree.prototype.maximumAux=function(node){while(node.rightCh!==null){node=node.rightCh}return node};buckets.BSTree.prototype.successorNode=function(node){if(node.rightCh!==null){return this.minimumAux(node.rightCh)}var successor=node.parent;while(successor!==null&&node===successor.rightCh){node=successor;successor=node.parent}return successor};buckets.BSTree.prototype.heightAux=function(node){if(node===null){return-1}return Math.max(this.heightAux(node.leftCh),this.heightAux(node.rightCh))+1};buckets.BSTree.prototype.insertNode=function(node){var parent=null;var position=this.root;var cmp=null;while(position!==null){cmp=this.compare(node.element,position.element);if(cmp===0){return null}else if(cmp<0){parent=position;position=position.leftCh}else{parent=position;position=position.rightCh}}node.parent=parent;if(parent===null){this.root=node}else if(this.compare(node.element,parent.element)<0){parent.leftCh=node}else{parent.rightCh=node}return node};buckets.BSTree.prototype.createNode=function(element){return{element:element,leftCh:null,rightCh:null,parent:null}};return buckets});